include Java

require 'rubygems'
require 'rubeus'
require 'MouseHandler'
require 'KeyHandler'
require 'net/http'
require 'rexml/document'

class Presen
	include Rubeus::Awt
	include Rubeus::Swing
  
  def initialize
    self.load
    $slide_number = -1
  end
  
	def show
		@frame = JFrame.new do |frame|
			frame.visible = true
			frame.set_background Color.black
			@message = JLabel.new 'RubeusPresen on Rails'
			@message.set_foreground Color.white
			@message.set_horizontal_alignment 0
			@message.set_vertical_alignment 0
			@mouse_handler = MouseHandler.new({:presen => self, :frame => frame, :message => @message})
      @message.add_mouse_listener @mouse_handler
		end
    @frame.add_key_listener KeyHandler.new({:presen => self, :frame => @frame, :message => @message})
	end
	
	def load
    Net::HTTP.start('localhost', 3000) do |http|
      @result = http.get('/messages.xml')
    end
  	doc = REXML::Document.new @result.body

    $load_message = []
    doc.elements.each('/messages/message') do |node|
      $load_message << {:message => node.elements['message'].text.to_s, :extention => node.elements['extention'].text }
    end
  end
  
  def do_extention
    begin
      eval $load_message[$slide_number][:extention]
    rescue SyntaxError => e
      puts '[Syntax Error]Slide #'+$slide_number.to_s
      puts e.to_s
      puts $load_message[$slide_number][:extention]
    end
  end
  
  def small
    @mouse_handler.small
  end
end

app = Presen.new
app.show